#ifndef DUCHAMP_CATALOGUE_H_
#define DUCHAMP_CATALOGUE_H_

#include <iostream>
#include <duchamp/Detection/detection.hh>
#include <duchamp/Outputs/CatalogueSpecification.hh>
#include <duchamp/Outputs/CasaAnnotationWriter.hh>
#include <duchamp/Outputs/KarmaAnnotationWriter.hh>
#include <duchamp/Outputs/DS9AnnotationWriter.hh>

namespace duchamp
{
  
    template <class T>  class Catalogue
    {
    public:
	Catalogue();
	Catalogue(Param &par);
	Catalogue(const Catalogue& other);
	Catalogue& operator= (const Catalogue& other);
	virtual ~Catalogue();
    
	T operator()(size_t i){return itsMemberList.at(i);};
	size_t size(){return itsMemberList.size();};

	Catalogues::CatalogueSpecification &spec(){return itsSpecification;};
	void setSpec(Catalogues::CatalogueSpecification spec){itsSpecification = spec;};
    
	void writeKarma();
	void writeDS9();
	void writeCasa();

    protected:
	std::vector<T> itsMemberList;
	Catalogues::CatalogueSpecification itsSpecification;

	KarmaAnnotationWriter itsKarmaWriter;
	DS9AnnotationWriter itsDS9Writer;
	CasaAnnotationWriter itsCasaWriter;

    };


}

#endif
